# -*- coding:Utf-8 -*-
# rank_cut V.1.224p by DoCky (21/04/2009)
# helped by EmbouT and Nicolous


import cPickle, os.path, es, langlib, popuplib, gamethread

info = es.AddonInfo()
info.author = "DoCky"
info.name = "rank_cut"
info.version = "1.224p"
info.url = "http://addons.eventscripts.com/addons/user/11751"

path = es.getAddonPath(info.name)
vers = es.ServerVar(info.name, "", "By DoCky -")
vers.set(info.version)
vers.makepublic()

command = es.ServerVar("rc_menu")
record = es.ServerVar("rc_list")
reset = es.ServerVar("rc_zero")

popuplist = set()
playerlist = []

class Joueur(object):
    def __init__(self, steamid, frag, name):
        self.steamid = steamid
        self.frag = frag
        self.name = name

    def __add__(self, name):
        self.frag += 1
        self.name = name

    def __cmp__(self, joueur):
        return cmp(self.frag, joueur.frag)

    def __eq__(self, valeur):
        return self.steamid == valeur

class Langage:
    def __init__(self):
        self.lang = langlib.Strings(path + "/language.ini")

    def exists(self, n):
        if self.lang.has_key(n): return True
        else: return False

    def getLang(self, i):
        try: lang = langlib.getLangAbbreviation(es.createplayerlist(i)[i]["language"])
        except KeyError: lang = langlib.getDefaultLang()
        finally: return lang

    def getText(self, n, i, f = {}):
        if len(f): return self.lang(n, opts = f, lang = self.getLang(i))
        else: return self.lang(n, lang = self.getLang(i))


def dataSave():
    cPickle.dump(
        map(lambda joueur: (joueur.steamid, joueur.frag, joueur.name), playerlist),
        open(path + "/datasave.ini", "w"))
    dataList()

def dataLoad():
    if not os.path.isfile(path + "/datasave.ini"): dataSave()
    global playerlist
    playerlist = []
    for joueur in cPickle.load(open(path + "/datasave.ini", "r")):
        playerlist.append(Joueur(joueur[0], joueur[1], joueur[2]))

def dataList():
    index = 0
    playerlist.sort(reverse = True)
    fichier = open("%s/cfg/rank_cut_list.txt" % es.ServerVar("eventscripts_gamedir"), "w")
    fichier.write('// ranklist created\n\n\n\n')
    for joueur in playerlist:
        index += 1
        fichier.write("[\t\t# %s\t\t]\n" % index +
                      "\t* %s\n" % joueur.steamid +
                      "\t* %s\n" % joueur.name +
                      "\t* %s\n\n" % joueur.frag)
    if not index: fichier.write("[\t\t\t\t]")
    fichier.write("\n\n\n\n// ranklist created")
    fichier.close()

def dataRemo():
    count = es.getargc()
    if count != 2: es.dbgmsg(0, "[rank_cut] syntax : %s <steamid / #all>")
    else:
        argument = es.getargv(1).upper()
        if argument == "#ALL":
            global playerlist
            playerlist = []
            dataSave()
            es.dbgmsg(0, "[rank_cut] data reinitialised !")
        elif argument in playerlist:
            playerlist.remove(argument)
            es.dbgmsg(0, "[rank_cut] steamid removed : %s" % argument)
        else: es.dbgmsg(0, "[rank_cut] cannot remove steamid : %s" % argument)

def menuRank():
    rank = []
    usid = es.getcmduserid()
    unid = es.getplayersteamid(usid)
    menu = "rank_menu_%s" % unid

    playerlist.sort(reverse = True)
    for joueur in playerlist: rank.append(_lang.getText("ranking", usid, {"playername" : joueur.name, "playerkill" : joueur.frag}))
    if not rank: rank = (_lang.getText("emptie", usid),)

    if menu in popuplist:
        popuplib.close(menu, usid)
        popuplib.delete(menu)

    rankcut = popuplib.easylist(menu, rank)
    rankcut.settitle(_lang.getText("title", usid))
    rankcut.send(usid)
    popuplist.add(menu)

def init():
    global _lang
    es.server.cmd("es_xmexec rank_cut/rank_cut.txt")
    for menu in popuplist: popuplib.delete(menu)
    _lang = Langage()
    popuplist.clear()
    dataLoad()

def load():
    es.server.cmd("es_xmexec rank_cut/rank_cut.txt")
    es.regsaycmd(str(command), "rank_cut/menuRank", "display rank cut menu")
    es.regclientcmd(str(command), "rank_cut/menuRank", "display rank cut menu")
    if not es.exists("command", str(record)): es.regcmd(str(record), "rank_cut/dataList", "create rank_cut_list file")
    if not es.exists("command", str(reset)): es.regcmd(str(reset), "rank_cut/dataRemo", "remove a/all rank(s) of classement")
    init()

def unload():
    for menu in popuplist: popuplib.delete(menu)
    es.unregclientcmd(str(command))
    es.unregsaycmd(str(command))
    dataSave()

def es_map_start(ev):
    dataSave()
    init()

def player_death(ev):
    if ev["weapon"] == "knife" and ev["es_attackersteamid"] != "BOT" and ev["es_attackersteamid"] != "STEAM_ID_PENDING" and ev["es_userteam"] != ev["es_attackerteam"]:
        if ev["es_attackersteamid"] in playerlist: playerlist[playerlist.index(ev["es_attackersteamid"])] + ev["es_attackername"]
        else: playerlist.append(Joueur(ev["es_attackersteamid"], 1, ev["es_attackername"]))
